//------------------------------------------------------------------ 
#property copyright "www.forex-tsd.com" 
#property link      "www.forex-tsd.com" 
//------------------------------------------------------------------
#property indicator_separate_window 
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    T3Price      = PRICE_CLOSE;
extern bool   T3Original   = false;
extern double T3MainPeriod = 11;
extern int    T3MainShift  = 0;
extern double T3MainHot    = 0.4;
extern string T3Periods    = "5;10;15;20;25;30;40";
extern string T3Shifts     = "0;0;0;0;0;0;0";
extern string T3Hots       = "0.4;0.4;0.4;0.4;0.4;0.4;0.4";

//
//
//
//
//

double tshuu[];
double tshud[];
double tshdd[];
double tshdu[];
double tshdn[];
double ts[];
double slope[];
double periods[];
double shifts[];
double hots[];
int    total;
int    repaints;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void addPeriod(int period)
{
   if (period>0)
   {
      total = ArraySize(periods)+1;
              ArrayResize(periods,total);
                          periods[total-1] = period;
   }
}

//
//
//
//
//

int init() 
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,tshuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tshud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tshdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tshdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tshdn); SetIndexStyle(4, DRAW_HISTOGRAM);
   SetIndexBuffer(5,ts);
   SetIndexBuffer(6,slope);
   
      //
      //
      //
      //
      //
      
      T3Periods = StringTrimLeft(StringTrimRight(T3Periods));
      if (StringSubstr(T3Periods,StringLen(T3Periods),1) != ";")
                       T3Periods = StringConcatenate(T3Periods,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(T3Periods,";",s);
            while (i > 0)
            {
               addPeriod(StrToInteger(StringSubstr(T3Periods,s,i-s)));
               s = i + 1; i = StringFind(T3Periods,";",s);
            }
            total = MathMin(total,15);
 
      //
      //
      //
      //
      //
         
      T3Shifts = StringTrimLeft(StringTrimRight(T3Shifts));
      if (StringSubstr(T3Shifts,StringLen(T3Shifts),1) != ";")
                       T3Shifts = StringConcatenate(T3Shifts,";");

         //
         //
         //
         //
         //                                   
         
         ArrayResize(shifts,total); ArrayInitialize(shifts,0);   
         s = 0;
         i = StringFind(T3Shifts,";",s);
         int current = 0;
            while (i > 0 && current<total)
            {
               int shift = StrToInteger(StringSubstr(T3Shifts,s,i-s));
                   shifts[current] = shift;
                   current += 1; s = i + 1; i = StringFind(T3Shifts,";",s);
                   
            }
            repaints = shifts[ArrayMinimum(shifts)];

      //
      //
      //
      //
      //
      
      T3Hots = StringTrimLeft(StringTrimRight(T3Hots));
      if (StringSubstr(T3Hots,StringLen(T3Hots),1) != ";")
                       T3Hots = StringConcatenate(T3Hots,";");

         //
         //
         //
         //
         //                                   
         
         ArrayResize(hots,total); ArrayInitialize(hots,T3MainHot);   
         s = 0;
         i = StringFind(T3Hots,";",s);
         current = 0;
            while (i > 0 && current<total)
            {
               double hot = StrToDouble(StringSubstr(T3Hots,s,i-s));
                      hots[current] = hot;
                      current += 1; s = i + 1; i = StringFind(T3Hots,";",s);
                   
            }

      //
      //
      //
      //
      //
            
      string name = "";
         for (i=0; i<total; i++)
         {  
            if (name!="")
                name = name+",";
                name = name+DoubleToStr(periods[i],1);
         }         
      IndicatorShortName("T3 trend strength ("+name+")"); 
   return(0); 
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{ 
   int counted_bars=IndicatorCounted();
      if (counted_bars < 0) return(-1);
      if (counted_bars > 0) counted_bars--;
      if (repaints<0)
           int limit = MathMin(MathMax(Bars-counted_bars,MathAbs(repaints)),Bars-1);
      else     limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
            
   for (int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,T3Price,MathMax(i+T3MainShift,0));
      double first = iT3(price,T3MainPeriod,T3MainHot,T3Original,i,0);
      double sum   = 0;
         for (int k=0; k<total; k++)
            {
               price = iMA(NULL,0,1,0,MODE_SMA,T3Price,MathMax(i+shifts[k],0));
               sum  += (first-iT3(price,periods[k],hots[k],T3Original,i,k+1));
            }

         //
         //
         //
         //
         //
                                              
         tshuu[i] = EMPTY_VALUE;         
         tshud[i] = EMPTY_VALUE;         
         tshdd[i] = EMPTY_VALUE;         
         tshdu[i] = EMPTY_VALUE;         
         tshdn[i] = EMPTY_VALUE;         
         ts[i]    = sum/total;
            if (i+repaints<0) { tshdn[i]=ts[i]; continue; }

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (ts[i] > ts[i+1]) slope[i] =  1;
               if (ts[i] < ts[i+1]) slope[i] = -1;
               if (ts[i]>0)
               if (slope[i]==1)
                     tshuu[i] = ts[i];
               else  tshud[i] = ts[i];
               if (ts[i]<0)
               if (slope[i]==1)
                     tshdu[i] = ts[i];
               else  tshdd[i] = ts[i];
   } 
   return(0); 
} 


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][96];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}